package com.example.kaveh.feature.main.adapter

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.kaveh.R
import com.example.kaveh.data.entity.category.CategoryItem
import com.example.kaveh.data.entity.category.SubCategory
import com.example.kaveh.services.ImageLoadingService
import com.example.kaveh.view.KavehImageView



class CategoryListAdapter(val imageLoadingService: ImageLoadingService) :
    RecyclerView.Adapter<CategoryListAdapter.ViewHolder>()
{


    var category = ArrayList<CategoryItem>()
        set(value) {
            field = value
            notifyDataSetChanged()
        }




    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        return ViewHolder(
            LayoutInflater.from(parent.context).inflate(R.layout.item_category, parent, false)
        )
    }

    override fun onBindViewHolder(holder: CategoryListAdapter.ViewHolder, position: Int) {

        if (category!!.isNotEmpty())
            holder.bindCategory(category[position])


    }


    override fun getItemCount(): Int = category.size

//    fun clear() {
//        category.clear()
//        notifyDataSetChanged()
//    }
//
//
//    fun addAll(list: List<CategoryItem>) {
//        category.addAll(list)
//        notifyDataSetChanged()
//    }

    inner class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val categoryIv: KavehImageView = itemView.findViewById(R.id.imageCategoryItem)
        val titleTv: TextView = itemView.findViewById(R.id.textCategoryItemTitle)
        val categoryItemRv: RecyclerView = itemView.findViewById(R.id.categorySubItemRv)


        fun bindCategory(category: CategoryItem) {

                imageLoadingService.let{
                    imageLoadingService.load(categoryIv, category.category_url)
                }

                titleTv.text = category.category_name

                categoryItemRv.layoutManager = LinearLayoutManager(
                    categoryItemRv.context,
                    RecyclerView.HORIZONTAL, false
                )

            val categorySubListAdapter=CategorySubListAdapter(
                imageLoadingService,
                category.sub_category,
                category.id,
            )

                categoryItemRv.adapter = categorySubListAdapter
           // categorySubListAdapter.onCategoryClickListener = this

        }
    }

}
